/*
 *   Program to decipher message using OKAMOTO private key.
 */

#include <stdio.h>
#include "miracl.h"

void strip(name)
char name[];
{ /* strip extension off filename */
    int i;
    for (i=0;name[i]!='\0';i++)
    {
        if (name[i]!='.') continue;
        name[i]='\0';
        break;
    }
}

main()
{  /*  decipher using private key  */
    big m,pq,p,q,a,c;
    FILE *ifile;
    FILE *ofile;
    char ifname[13],ofname[13];
    bool flo;
    mirsys(100,MAXBASE);
    m=mirvar(0);
    pq=mirvar(0);
    p=mirvar(0);
    q=mirvar(0);
    a=mirvar(0);
    c=mirvar(0);
    IOBASE=60;
    ifile=fopen("private.key","r");
    cinnum(p,ifile);
    cinnum(q,ifile);
    cinnum(a,ifile);
    fclose(ifile);
    multiply(p,q,pq);
    do
    { /* get input file */
        printf("file to be deciphered = ");
        gets(ifname);
    } while (strlen(ifname)==0);
    strip(ifname);
    strcat(ifname,".oka");
    printf("output filename = ");
    gets(ofname);
    flo=FALSE;
    if (strlen(ofname)>0) 
    { /* set up output file */
        flo=TRUE;
        ofile=fopen(ofname,"w");
    }
    printf("deciphering message\n");
    ifile=fopen(ifname,"r");
    forever
    { /* decipher line by line */
        IOBASE=60;
        cinnum(c,ifile);
        if (size(c)==0) break;
        divide(c,pq,pq);
        root(c,2,c);
        subtract(c,a,m);
        IOBASE=128;
        if (flo) cotnum(m,ofile);
        cotnum(m,stdout);
    }
    fclose(ifile);
    if (flo) fclose(ofile);
    printf("message ends\n");
}
